osg::UserDataContainer Class Referenceabstract

`#include <UserDataContainer>`

Inheritance diagram for osg::UserDataContainer:

## Public Types

typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| UserDataContainer ()
| UserDataContainer (const UserDataContainer &udc, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual void | setUserData (Referenced *obj)=0
virtual Referenced * | getUserData ()=0
virtual const Referenced * | getUserData () const =0
virtual unsigned int | addUserObject (Object *obj)=0
template<class T>
unsigned int | addUserObject (const osg::ref_ptr< T > &obj)
virtual void | setUserObject (unsigned int i, Object *obj)=0
virtual void | removeUserObject (unsigned int i)=0
virtual Object * | getUserObject (unsigned int i)=0
virtual const Object * | getUserObject (unsigned int i) const =0
virtual unsigned int | getNumUserObjects () const =0
virtual unsigned int | getUserObjectIndex (const osg::Object *obj, unsigned int startPos=0) const =0
virtual unsigned int | getUserObjectIndex (const std::string &name, unsigned int startPos=0) const =0
virtual Object * | getUserObject (const std::string &name, unsigned int startPos=0)
virtual const Object * | getUserObject (const std::string &name, unsigned int startPos=0) const
virtual void | setDescriptions (const DescriptionList &descriptions)=0
virtual DescriptionList & | getDescriptions ()=0
virtual const DescriptionList & | getDescriptions () const =0
virtual unsigned int | getNumDescriptions () const =0
virtual void | addDescription (const std::string &desc)=0
template<class T>
void | setUserData (const ref_ptr< T > &ud)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
template<class T>
void | setUserData (const ref_ptr< T > &ud)
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~UserDataContainer ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

Internal structure for storing all user data.

## Member Typedef Documentation

## DescriptionList

typedef std::vector<std::string> osg::UserDataContainer::DescriptionList

## Constructor & Destructor Documentation

## UserDataContainer() [1/2]

osg::UserDataContainer::UserDataContainer | ( |  | ) |

Referenced by asUserDataContainer(), asUserDataContainer(), isSameKindAs(), and UserDataContainer().

## UserDataContainer() [2/2]

osg::UserDataContainer::UserDataContainer | ( | const UserDataContainer & | udc,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and UserDataContainer().

## ~UserDataContainer()

virtual osg::UserDataContainer::~UserDataContainer | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addDescription()

virtual void osg::UserDataContainer::addDescription | ( | const std::string & | desc | ) |

pure virtual

Add a description string.

Implemented in osg::DefaultUserDataContainer.

## addUserObject() [1/2]

template<class T>

unsigned int osg::UserDataContainer::addUserObject | ( | const osg::ref_ptr< T > & | obj | ) |

inline

References addUserObject(), and osg::ref_ptr< T >::get().

Referenced by addUserObject().

## addUserObject() [2/2]

virtual unsigned int osg::UserDataContainer::addUserObject | ( | Object * | obj | ) |

pure virtual

Add user data object. Returns the index position of object added.

Implemented in osg::DefaultUserDataContainer.

References osg::Object::Object().

Referenced by osg::getOrCreateUserObjectOfType(), osgDB::ClassInterface::setProperty(), osg::DefaultUserDataContainer::setUserData(), and osg::Object::setUserValue().

## asUserDataContainer() [1/2]

virtual UserDataContainer * osg::UserDataContainer::asUserDataContainer | ( |  | ) |

inline virtual

Convert 'this' into a UserDataContainer pointer if Object is a UserDataContainer, otherwise return 0. Equivalent to dynamic_cast<UserDataContainer*>(this).

Reimplemented from osg::Object.

References UserDataContainer().

## asUserDataContainer() [2/2]

virtual const UserDataContainer * osg::UserDataContainer::asUserDataContainer | ( |  | ) | const

inline virtual

convert 'const this' into a const UserDataContainer pointer if Object is a UserDataContainer, otherwise return 0. Equivalent to dynamic_cast<const UserDataContainer*>(this).

Reimplemented from osg::Object.

References UserDataContainer().

## className()

virtual const char * osg::UserDataContainer::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

## getDescriptions() [1/2]

virtual const DescriptionList & osg::UserDataContainer::getDescriptions | ( |  | ) | const

pure virtual

Get the const description list.

Implemented in osg::DefaultUserDataContainer.

## getDescriptions() [2/2]

virtual DescriptionList & osg::UserDataContainer::getDescriptions | ( |  | ) |

pure virtual

Get the description list.

Implemented in osg::DefaultUserDataContainer.

## getNumDescriptions()

virtual unsigned int osg::UserDataContainer::getNumDescriptions | ( |  | ) | const

pure virtual

Get number of description strings.

Implemented in osg::DefaultUserDataContainer.

## getNumUserObjects()

virtual unsigned int osg::UserDataContainer::getNumUserObjects | ( |  | ) | const

pure virtual

Get number of user objects assigned to this object.

Implemented in osg::DefaultUserDataContainer.

Referenced by osg::runNamedCallbackObjects().

## getUserData() [1/2]

virtual const Referenced * osg::UserDataContainer::getUserData | ( |  | ) | const

pure virtual

Get const user data.

Reimplemented from osg::Object.

Implemented in osg::DefaultUserDataContainer.

## getUserData() [2/2]

virtual Referenced * osg::UserDataContainer::getUserData | ( |  | ) |

pure virtual

Get user data.

Reimplemented from osg::Object.

Implemented in osg::DefaultUserDataContainer.

## getUserObject() [1/4]

virtual Object * osg::UserDataContainer::getUserObject | ( | const std::string & | name,
|  | unsigned int | startPos = 0 )

virtual

Get first user data object with specified name.

References osg::Object::Object().

## getUserObject() [2/4]

virtual const Object * osg::UserDataContainer::getUserObject | ( | const std::string & | name,
|  | unsigned int | startPos = 0 ) const

virtual

Get first const user data object with specified name.

References osg::Object::Object().

## getUserObject() [3/4]

virtual const Object * osg::UserDataContainer::getUserObject | ( | unsigned int | i | ) | const

pure virtual

Get const user data object as specified index position.

Implemented in osg::DefaultUserDataContainer.

References osg::Object::Object().

## getUserObject() [4/4]

virtual Object * osg::UserDataContainer::getUserObject | ( | unsigned int | i | ) |

pure virtual

Get user data object as specified index position.

Implemented in osg::DefaultUserDataContainer.

References osg::Object::Object().

Referenced by osg::getCallbackObject(), osg::getCallbackObject(), osg::getOrCreateUserObjectOfType(), osgDB::ClassInterface::getProperty(), osg::getUserObject(), osg::getUserObject(), osg::Object::getUserValue(), osg::runNamedCallbackObjects(), osgDB::ClassInterface::setProperty(), and osg::Object::setUserValue().

## getUserObjectIndex() [1/2]

virtual unsigned int osg::UserDataContainer::getUserObjectIndex | ( | const osg::Object * | obj,
|  | unsigned int | startPos = 0 ) const

pure virtual

Get the index position of specified user data object.

Implemented in osg::DefaultUserDataContainer.

Referenced by osg::getOrCreateUserObjectOfType(), osgDB::ClassInterface::setProperty(), and osg::Object::setUserValue().

## getUserObjectIndex() [2/2]

virtual unsigned int osg::UserDataContainer::getUserObjectIndex | ( | const std::string & | name,
|  | unsigned int | startPos = 0 ) const

pure virtual

Get the index position of first user data object that matches specified name.

Implemented in osg::DefaultUserDataContainer.

## isSameKindAs()

virtual bool osg::UserDataContainer::isSameKindAs | ( | const Object * | obj | ) | const

inline virtual

Reimplemented from osg::Object.

References osg::Object::Object(), and UserDataContainer().

## libraryName()

virtual const char * osg::UserDataContainer::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

## removeUserObject()

virtual void osg::UserDataContainer::removeUserObject | ( | unsigned int | i | ) |

pure virtual

Remove element from the list of user data objects.

Implemented in osg::DefaultUserDataContainer.

## setDescriptions()

virtual void osg::UserDataContainer::setDescriptions | ( | const DescriptionList & | descriptions | ) |

pure virtual

Set the list of string descriptions.

Implemented in osg::DefaultUserDataContainer.

## setUserData() [1/2]

template<class T>

void osg::Object::setUserData | ( | const ref_ptr< T > & | ud | ) |

inline

## setUserData() [2/2]

virtual void osg::UserDataContainer::setUserData | ( | Referenced * | obj | ) |

pure virtual

Set user data, data must be subclassed from Referenced to allow automatic memory handling. If your own data isn't directly subclassed from Referenced then create an adapter object which points to your own object and handles the memory addressing.

Reimplemented from osg::Object.

Implemented in osg::DefaultUserDataContainer.

References osg::Object::setUserData().

## setUserObject()

virtual void osg::UserDataContainer::setUserObject | ( | unsigned int | i,
|  | Object * | obj )

pure virtual

Add element to list of user data objects.

Implemented in osg::DefaultUserDataContainer.

References osg::Object::Object().

Referenced by osg::getOrCreateUserObjectOfType(), osgDB::ClassInterface::setProperty(), and osg::Object::setUserValue().

The documentation for this class was generated from the following file:

- UserDataContainer